//+------------------------------------------------------------------+
//|                                         PolyFitScalper_v1.58.mq4 |
//|                        Copyright  2008-09, TrendLaboratory Ltd. |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008-09, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#include <stdlib.mqh>

//---- input parameters
extern string     Expert_Name    = "PolyFitScalper_v1.60a";

extern int        Magic          =158158;    // Magic Number
extern int        Slippage       =     3;

extern string     Main_data      = " Trade Volume & Trade Method";
extern double     Lots           =  0.01;    // Trade Volume 
extern int        MaxOrders      =    10;    // Max Orders Number
extern double     TakeProfit     =     0;    // Take Profit Value in pips 
extern double     ProfitTarget   =     0;    // Profit Target Value
extern double     ProfitMode     =     0;    // Profit Mode for Profit Target:0-pips,1-USD
extern double     MinProfit      =     1;    // Min Profit in pips
extern double     ProfitRatio    =   0.5;    // For Profit Close: Distance from Up/Dn Bands in portions of width (ex.0.5-middle)  
extern double     LossRatio      =     0;    // For Loss Close: the same as Profit Close   
extern double     StopLoss       =     0;    // Initial Stop Value in pips
extern int        TrailingMode   =     0;    // 0-off,1-standard,2-System by Up/Dn Bands  
extern double     TrailingStop   =     0;    // Trailing Stop Value in pips
extern double     StopDeviation  =     0;    // Deviation from Up/Dn Bands in %(TrailingMode=2)
extern double     BreakEven      =     0;    // Break-Even Value in pips
extern double     PipsLock       =     0;    // Lock in pips
extern int        ExitMode       =     1;    // Exit Mode: 0-off, 1-on
extern int        ECN_Mode       =     0;    // ECN Mode: 0-off,1-on 
extern int        Comment_Mode   =     0;    // Comment Mode: 0-off,1-on 

extern string     Time_Inputs    = " Timing parameters ";
extern int        MainTimeFrame  =     0;    // Time Frame in min
extern int        StartHour      =     0;    // Start Hour of Trade Session 
extern int        StartMinute    =     0;    // Start Minute of Trade Session 
extern int        EndHour        =     0;    // End Hour of Trade Session
extern int        EndMinute      =     0;    // End Hour of Trade Session
extern int        MonStartHour   =     0;    // Monday Start Hour of Trade Session 
extern int        MonStartMinute =     0;    // Monday Start Minute of Trade Session 
extern int        FriEndHour     =     0;    // Friday End Hour of Trade Session
extern int        FriEndMinute   =     0;    // Friday End Hour of Trade Session
extern int        TradeDay       =    -1;    // Trade Day of Week (ex.1-Monday,-1-all Days) 
extern int        NonTradeDay    =     0;    // Non-Trading Day of Week (ex.5-Friday)   
extern int        CloseTimeMode  =     0;    // CloseTime mode: 0-off,1-on
extern int        CloseHour      =     0;    // Trade Close Hour   
extern int        CloseMinute    =     0;    // Trade Close Minute   
extern int        FriCloseHour   =    24;    // Trade Close Hour in Friday   
extern int        FriCloseMinute =    55;    // Trade Close Minute in Friday 
extern double     ProcessTime    =     3;    // Process Time for Close Orders by Time
extern double     OrdDuration    =   1.5;    // Min Orders duration
extern string     ScheduleName   = "EURCHF_M1.txt"; // Name of Schedule's File
extern int        ScheduleCheck  =     0;    // Check of Schedule in Experts Window 
extern int        ScheduleMode   =     1;    // Schedule Mode: 0-off,1-on  
extern int        TimeShift      =     0;    // Time Shift in hours (for Schedule only)

extern string     PS_Inputs      = " PolyFitBands parameters:";
extern int        PS_TimeFrame   =     0;    // Time Frame in min
extern int        PS_Price       =     0;    // Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median;5-Typical;6-Weighted)
extern int        PS_Length      =   150;    // Number of bars for an evaluation
extern int        PS_Degree      =     1;    // Degree of a Polynomial(no more 12)
extern int        PS_PreSmooth   =     1;    // Period of Preliminary Smoothing
extern int        PS_MAMode      =     0;    // Mode of MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA
extern double     PS_Sigma_min   =   2.0;    // Min value of Multiplier of Sigma(Standard Deviation)
extern double     PS_Sigma_max   =   4.0;    // Max value of Multiplier of Sigma(Standard Deviation)
extern double     PS_MaxDistance =     0;    // Max Distance from middle in pips
extern int        PS_Shift       =     0;    // Shift relative to the current bar
extern int        PS_Mode        =     1;    // PolyTrend Mode: 0-off,1-trend(confirmation),2-signal
extern int        DeadZonePip    =    30;    // from watta attar explosion
extern int        BandsPeriod    =     8;    // non lag bbands
extern double     BandsDeviations=    3.0;   // non lag bbands 


extern string     MM_inputs       = " Money Management";
extern int        MM              =     3;    //  Switch(0-off,1-%% of Free Margin,2-L.Williams formula,3-Martingale
extern double     MaxRisk         =  0.02;    // Risk Factor in decimals 
extern double     MaxLots         =     3;    // Max Lots Size
extern double     MGLotMultiplier =    1.5;    // Lot multiplier for martingale
extern int        MGPipStep       =     9;    // if > 0, minimal distance in pips from the last price
extern bool       MGStopOnMaxLot  =   false;  // Should it continue opening orders when maxLost reached


int      OrderBar=0;
double   Lotsi;
int      BEvent=0, TriesNum=5, EventNum;
datetime CurrBar,PrevBar,pTime;
double   UpBand[], DnBand[];

int      BEbar;

double   lot_min;
double   lot_max;
double   lot_step;
double   contract; 
double   tick_val,spread;
double   minstop;
int      NumOrders;  
double   aLots[], MaxLoss;
double   _Point;
double   upband[3],dnband[3],poly[3],b_dist,p_dist;
double   stopUpBand, stopDnBand;
double   Explo1, Explo2, Dead;
int      bLevel, sLevel;
datetime prevTime;
bool     fTime = true, timecond = false;
string   sDate[],sTime[],eTime[];          
datetime pmin;
double   lastOrders[][3];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
//---- 
   if (PS_TimeFrame==0) PS_TimeFrame = Period();
   if (MainTimeFrame==0) MainTimeFrame = Period(); 
   
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   PrevBar = iTime(Symbol(),MainTimeFrame,1);
   
   lot_max  = MarketInfo(Symbol(),MODE_MAXLOT);
   lot_min  = MarketInfo(Symbol(),MODE_MINLOT);
   lot_step = MarketInfo(Symbol(),MODE_LOTSTEP);
   contract = MarketInfo(Symbol(),MODE_LOTSIZE);   
   tick_val = MarketInfo(Symbol(),MODE_TICKVALUE)*MathPow(10,Digits%2);
   minstop  = MarketInfo(Symbol(),MODE_STOPLEVEL)/MathPow(10,Digits%2);
   _Point   = MarketInfo(Symbol(),MODE_POINT)*MathPow(10,Digits%2);
//----
   ArrayResize(UpBand,MaxOrders);
   ArrayResize(DnBand,MaxOrders);
     
   return(0);
}

// ---- Scan Trades
int ScanTrades(int ord,int mode)
{   
   int  total   = OrdersTotal();
   int  numords = 0;
   bool type    = false; 
   int  trd     = 0;
   
   ArrayResize(lastOrders,2);
   ArrayInitialize(lastOrders,0);
      
   //
   //
   //
   //
   //
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
      OrderSelect(cnt, SELECT_BY_POS);            
      if ( ord != 0 )
      {
         if ( OrderType()==0 || OrderType()==2 || OrderType()==4 ) trd =  1;
         if ( OrderType()==1 || OrderType()==3 || OrderType()==5 ) trd =  2;      
      } else trd=0;
         
      if (mode == 0) type = OrderType()<=OP_SELLSTOP;
      if (mode == 1) type = OrderType()<=OP_SELL;   
      if (mode == 2) type = OrderType()>OP_SELL && OrderType()<=OP_SELLSTOP; 
   
      if(OrderSymbol() == Symbol() && type && trd==ord && OrderMagicNumber() == Magic)  
      numords++;
   }
   return(numords);
}

//
//
//
//
//


//-----
void ReadSchedule(string fName)
{    
   int i, k, handle;
   
   ArrayResize(sDate,0);
   ArrayResize(sTime,0);
   ArrayResize(eTime,0);
     
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
   
   if(handle<1)
   {
   Print("File not found ", GetLastError());
   return(false);
   }
   else
   if(handle>=1)
   {
   i=0;
      while(!FileIsEnding(handle))
      {
      k = ArraySize(sDate);
      
      ArrayResize(sDate,k+1);
      ArrayResize(sTime,k+1);
      ArrayResize(eTime,k+1);
                
      sDate[i]=FileReadString(handle);          
      sTime[i]=FileReadString(handle);             
      eTime[i]=FileReadString(handle);
      FileReadString(handle); // null
          
      
         if(ScheduleCheck>0)
         {
         string info = i+"_"+sDate[i]+"_"+sTime[i]+"_"+eTime[i];
         Print( info );
         }
      i++;
      }
   FileClose(handle);
   }
   EventNum = i;
   
return(0);
}

bool TimeCondition()
{
   bool result = false;
   if(ScheduleMode == 0)
   { 
      if(((TradeDay >= 0 && DayOfWeek() == TradeDay) || TradeDay == -1) && DayOfWeek()!= NonTradeDay)
      {
         if(StartHour == 24) StartHour = 0; 
      
         datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
         double Start = StartHour + StartMinute/60.0;
         datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
         double End   = EndHour + EndMinute/60.0; 
         
         if(DayOfWeek() != 1 && DayOfWeek() != 5)
         {    
            if (Start < End) result = (TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd);      
            else
            if (Start > End)
            result = (TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59))
                   ||(TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd);
         }
         else
         if(DayOfWeek() == 1)
         {    
            if(MonStartHour > 0 || MonStartMinute > 0) 
            {
            datetime MonSessionStart = StrToTime(MonStartHour+":"+MonStartMinute);
            double MonStart = MonStartHour + MonStartMinute/60.0;
            }
            else
            {
            MonSessionStart = StrToTime(0+":"+0); //SessionStart;
            MonStart = 0;//Start;
            }
                        
            if (Start < End)
            { 
               if (MonStart != 0) result = TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd;      
               else result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;
            }
            else
            if (Start > End)
            {
               result = (TimeCurrent() >= MonSessionStart && TimeCurrent() < SessionEnd) 
                      ||(TimeCurrent() >= SessionStart && TimeCurrent() < StrToTime(23+":"+59));
            }
         }
         else
         if(DayOfWeek() == 5)
         {
            if(FriEndHour > 0 || FriEndMinute > 0)
            {
            datetime FriSessionEnd   = StrToTime(FriEndHour+":"+FriEndMinute);
            double FriEnd   = FriEndHour + FriEndMinute/60.0; 
            }
            else
            {
            FriSessionEnd   = SessionEnd;
            FriEnd = End; 
            }
            
            if (Start < End)
            {
               if (FriEnd != End) result = TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd; 
               else
               result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;  
            }
            else
            if (Start > End)
               result = (TimeCurrent() >= StrToTime(0+":"+0) && TimeCurrent() < SessionEnd)
                      ||(TimeCurrent() >= SessionStart && TimeCurrent() < FriSessionEnd);
               
         }  
      }
   }
   else
   {
   datetime cTime = TimeCurrent() - TimeShift*3600;   
   int i = 0;
      while(i < EventNum)
      {                          
      bool v1 = false;
      
         if(sDate[i] == "ANY") v1 = true;
         else
         {   
            if(sDate[i] == "Sun" && TimeDayOfWeek(cTime)==0) v1 = true; 
            else
            if(sDate[i] == "Mon" && TimeDayOfWeek(cTime)==1) v1 = true;
            else
            if(sDate[i] == "Tue" && TimeDayOfWeek(cTime)==2) v1 = true;
            else
            if(sDate[i] == "Wed" && TimeDayOfWeek(cTime)==3) v1 = true;
            else
            if(sDate[i] == "Thu" && TimeDayOfWeek(cTime)==4) v1 = true;
            else
            if(sDate[i] == "Fri" && TimeDayOfWeek(cTime)==5) v1 = true;
            else
            if(sDate[i] == "Sat" && TimeDayOfWeek(cTime)==6) v1 = true;
         }       
      
      if(v1) string sday = TimeToStr(cTime,TIME_DATE); else sday = TimeToStr(0,TIME_DATE); 
                                      
      datetime sdt = StrToTime(sday +" "+sTime[i]);
      datetime edt = StrToTime(sday +" "+eTime[i]);              
      
      if(cTime >= sdt && cTime < edt) {result = true; break;}
      i++;
      }
   }   
   
   return(result);
}   

int PolyFitSignal(int mode,int tf,int p,int len,int deg,int malen,int mamode,double sigmin,double sigmax,int bar)
{   
   int result = 0; 
   static datetime prevTime;
   
   if(iTime(NULL,PS_TimeFrame,0) > prevTime)
   { 
      for(int j=1;j>=0;j--)
      {
      upband[j+1] = upband[j];
      dnband[j+1] = dnband[j];
      poly[j+1]   = poly[j];
      }
   prevTime = iTime(NULL,PS_TimeFrame,0);
   }   
    
   upband[0] = iCustom(NULL,tf,"PolyFitBands_v2.3",p,len,deg,malen,mamode,sigmin,0,0,bar,1,1,bar);
   dnband[0] = iCustom(NULL,tf,"PolyFitBands_v2.3",p,len,deg,malen,mamode,sigmin,0,0,bar,1,2,bar);
      Explo1 =(iCustom(NULL,0,"NonLagBands",BandsPeriod,0,BandsDeviations,0,0,MODE_UPPER,bar) - 
               iCustom(NULL,0,"NonLagBands",BandsPeriod,0,BandsDeviations,0,0,MODE_LOWER,bar));
      Explo2 =(iCustom(NULL,0,"NonLagBands",BandsPeriod,0,BandsDeviations,0,0,MODE_UPPER,bar+1) - 
               iCustom(NULL,0,"NonLagBands",BandsPeriod,0,BandsDeviations,0,0,MODE_LOWER,bar+1));
      Dead   = _Point * DeadZonePip;
   
   poly[0] = 0.5*(upband[0] + dnband[0]);
   b_dist  = 0.5*(upband[0] - dnband[0]); 
   p_dist  = MathAbs(Close[0] - poly[0]);
   
   if(StopDeviation > 0)
   {
   stopUpBand = poly[0] + StopDeviation * b_dist / sigmin; 
   stopDnBand = poly[0] - StopDeviation * b_dist / sigmin;
   }
   
   if (MaxOrders > 1) double step = (sigmax - sigmin)/(MaxOrders - 1);
   else step = 0; 
   
   for (int k = 0;k < MaxOrders;k++)
   {
   double del0 = b_dist/sigmin; 
   UpBand[k]  = NormalizeDouble(poly[0] + del0 * (sigmin + k * step),Digits); 
   DnBand[k]  = NormalizeDouble(poly[0] - del0 * (sigmin + k * step),Digits);  
   }
   
   if (MaxOrders > 1) {int bnum = ScanTrades(1,0); int snum = ScanTrades(2,0);}
   else {bnum = 0; snum =0;}
   
   if (mode == 1)
   {
   if (Ask < DnBand[bnum] && DnBand[bnum] > 0 && Explo1 > Dead && Explo2 > Dead && Explo1 < Explo2) result =  mode;
   if (Bid > UpBand[snum] + spread && UpBand[snum] > 0 && Explo1 > Dead && Explo2 > Dead && Explo1 < Explo2) result = -mode; 
   
      if(result != 0)
      {
      bLevel = bnum; 
      sLevel = snum;
      }
   }
   else
   if (mode == 2)
   {
   if (Ask < DnBand[bnum] && DnBand[bnum] > 0 && poly[0] > poly[1] && poly[1] > poly[2] && Explo1 > Dead && Explo2 > Dead && Explo1 < Explo2) result =  mode;
   if (Bid > UpBand[snum] && UpBand[snum] > 0 && poly[0] < poly[1] && poly[1] < poly[2] && Explo1 > Dead && Explo2 > Dead && Explo1 < Explo2) result = -mode; 
   
      if(result != 0)
      {
      bLevel = bnum; 
      sLevel = snum;
      }
   }
   else
   if(mode == 0) result = 0;
   
   return(result); 
}

int TradeSignal()
{   
   int PS = 0, Signal = 0;
      
   if (PS_Mode>0)
   {
   PS = PolyFitSignal(PS_Mode,PS_TimeFrame,PS_Price,PS_Length,PS_Degree,PS_PreSmooth,PS_MAMode,PS_Sigma_min,PS_Sigma_max,PS_Shift); 
      if(PS_MaxDistance == 0 || (PS_MaxDistance > 0 && p_dist > PS_MaxDistance * _Point))
      {   
      if (PS == PS_Mode) Signal = 1;
      if (PS ==-PS_Mode) Signal =-1;
      }
   }  
   return(Signal);
}



//---------------------------------------------------------------------
//
//---------------------------------------------------------------------
//
//
//
//

void ScanForMartingale()
{   
   int  total   = OrdersTotal();
   
   ArrayResize(lastOrders,2);
   ArrayInitialize(lastOrders,0);
      
   //
   //
   //
   //
   //
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
      OrderSelect(cnt, SELECT_BY_POS);            
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic)  
      {
         if (OrderType()==OP_BUY)
         if (OrderLots() > lastOrders[0][0])
         {
            lastOrders[0][0]=OrderLots();
            lastOrders[0][1]=OrderOpenPrice();
            lastOrders[0][2]=OrderOpenTime();
         }               
         if (OrderType()==OP_SELL)
         if (OrderLots() > lastOrders[1][0])
         {
            lastOrders[1][0]=OrderLots();
            lastOrders[1][1]=OrderOpenPrice();
            lastOrders[1][2]=OrderOpenTime();
         }               
      }
   }
}

//
//
//
//
//

bool MoneyManagement(int doWhat=0)
{
   double vol;
//--- check data
   if(lot_min<0 || lot_max<=0.0 || lot_step<=0.0) 
   {
   Print("CalculateVolume: invalid MarketInfo() results [",lot_min,",",lot_max,",",lot_step,"]");
   return(0);
   }
   if(AccountLeverage()<=0)
   {
   Print("CalculateVolume: invalid AccountLeverage() [",AccountLeverage(),"]");
   return(0);
   }
//--- basic formula
      
   if (MM == 3)
   {
      ScanForMartingale();
      if (doWhat==1)
      {
         if (lastOrders[0][0]>0)
               vol = lastOrders[0][0]*MGLotMultiplier;
         else  vol = Lots; 
      }
      if (doWhat==2)
      {
         if (lastOrders[1][0]>0)
               vol = lastOrders[1][0]*MGLotMultiplier;
         else  vol = Lots; 
      }
      
      //
      //
      //
      //
      //
      
      if (MaxLots > 0)
      if(vol > MaxLots)
      {
         if (MGStopOnMaxLot) 
                  return(false);
         else     vol = MaxLots;
      }
      
      //
      //
      //
      //
      //
      
      if (MGPipStep>0)
      {
         RefreshRates();
         if (doWhat==1 && lastOrders[0][1]>0)
         {
               if (Ask>lastOrders[0][1]-MGPipStep*_Point) return(false);
         }            
         if (doWhat==2 && lastOrders[1][1]>0)
         {
               if (Bid<lastOrders[1][1]+MGPipStep*_Point) return(false);
         }               
      }
   }
   else
      if (MM == 1)
         vol=NormalizeDouble(AccountFreeMargin()*MaxRisk*AccountLeverage()/contract,2); 
      else
      if (MM == 2 && MaxLoss > 0)
         vol = NormalizeDouble(AccountFreeMargin()*MaxRisk/MaxLoss,2);
      else
         vol=Lots;
//--- check min, max and step
   vol=NormalizeDouble(vol/lot_step,0)*lot_step;
   if (MaxLots > 0) lot_max = MaxLots;  
   if(vol<lot_min) vol=lot_min;
   
//---
   
   if(vol <= lot_max ) 
   {
   NumOrders = 1;
   ArrayResize(aLots,NumOrders);
   aLots[NumOrders-1]=vol;
   if(vol < lot_min) aLots[NumOrders-1]=lot_min;
   }  
   else
   if(vol > lot_max)
   {
   NumOrders = 1+MathFloor(vol/lot_max); 
   if(NumOrders > MaxOrders) NumOrders = MaxOrders; 
   
   ArrayResize(aLots,NumOrders);
      double SumVol = 0;
      for (int i=0; i<NumOrders-1;i++)
      {
      aLots[i] = MathCeil(vol/lot_step/NumOrders)*lot_step;
      if(aLots[i]>lot_max) aLots[i]=lot_max; 
      SumVol += aLots[i];
      }
      aLots[NumOrders-1] = vol - SumVol; 
      if (aLots[NumOrders-1]>lot_max) aLots[NumOrders-1]=lot_max;
   }         
//---
   if (NumOrders>0) return(true);
}   


void TrailStop()
{
   int    error;  
   bool   result=false;
   double Gain = 0;
   int    total = OrdersTotal(); 
   
   
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();    
      if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
      {
         if (mode==OP_BUY) 
         {
			   if (BreakEven > 0 && BEvent < total )
			   {
			   Gain = (MarketInfo(Symbol(),MODE_BID) - OrderOpenPrice())/_Point;
			      if( Gain >= BreakEven && OrderStopLoss()<=OrderOpenPrice()+PipsLock*_Point) 
			      {
			      double BuyStop = NormalizeDouble(OrderOpenPrice()+PipsLock*_Point,Digits);
			      BEvent+=1;
			      }
			   }
			   else			   
			   if (TrailingMode == 1 && TrailingStop > 0) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_BID) - TrailingStop*_Point,Digits);
			   else
			   if (TrailingMode == 2 && stopDnBand>0) BuyStop = NormalizeDouble(stopDnBand,Digits);
			   
			   if (MathAbs(Ask - BuyStop) < minstop*_Point) BuyStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) - minstop*_Point,Digits);   
             
			   if( NormalizeDouble(OrderOpenPrice(),Digits)<= BuyStop) 
            {   
			      if (BuyStop != NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
			      {
			         for(int k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              BuyStop,
			                              OrderTakeProfit(),0,Lime);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }   		 
               }            
            }
         }   
// - SELL Orders          
         if (mode==OP_SELL)
         {
            if (BreakEven > 0 && BEvent > -total)
			   {
			   Gain = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/_Point;
			   
			      if( Gain >= BreakEven && (OrderStopLoss()>=OrderOpenPrice()-PipsLock*_Point || OrderStopLoss()== 0)) 
			      {
			      double SellStop = NormalizeDouble(OrderOpenPrice()-PipsLock*_Point,Digits);
			      BEvent-=1;
			      }
			   }
			   else 
			   if (TrailingMode == 1 && TrailingStop > 0) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + TrailingStop*_Point,Digits);   
            else
            if (TrailingMode == 2 && stopUpBand>0) SellStop = NormalizeDouble(stopUpBand,Digits);
            
            if (MathAbs(Bid - SellStop) < minstop*_Point) SellStop = NormalizeDouble(MarketInfo(Symbol(),MODE_ASK) + minstop*_Point,Digits);   
                        
            if(NormalizeDouble(OrderOpenPrice(),Digits) >= SellStop && SellStop>0) 
            {
               if( SellStop != NormalizeDouble(OrderStopLoss(),Digits) || OrderStopLoss() == 0) 
               {
                  for( k = 0 ; k < TriesNum; k++)
                  {
                  result = OrderModify(OrderTicket(),OrderOpenPrice(),
			                              SellStop,
			                              OrderTakeProfit(),0,Orange);
                  error=GetLastError();
                     if(error==0) break;
                     else {Sleep(5000); RefreshRates(); continue;}
                  }
               }   
   			}	    
         }
      }
   }     
}

// ---- Open Sell Orders
void SellOrdOpen()
{		     
   double SellPrice = Bid, Stop, Profit;
   double StopPrice = Bid;
   int    Mode = OP_SELL;
     
   if (StopLoss > 0) double SellStop  = StopPrice + StopLoss*_Point; 
	else
	if (TrailingMode==2 && stopUpBand>0) SellStop = stopUpBand; 
	else 
	SellStop = 0;
   
   if(SellStop > 0 && SellStop - SellPrice < 10*_Point) SellStop = StopPrice + 10*_Point; 
   
   if (TakeProfit  > 0) double SellProfit = SellPrice - TakeProfit*_Point; 
   else 
   SellProfit=0;
   
   if (MM == 2 && SellStop > 0) MaxLoss = tick_val*(SellStop-SellPrice)/_Point;    
	 
	if(ECN_Mode > 0) {Stop = 0; Profit = 0;}
	else {Stop = SellStop; Profit = SellProfit;} 
	
	if(MoneyManagement(2))
	{
       
      for (int i=0; i<NumOrders;i++)
      {		
	   int ticket = OrderSend(Symbol(),Mode,aLots[i],
	                          NormalizeDouble(SellPrice , Digits),
	                          Slippage,
	                          NormalizeDouble(Stop  , Digits),
	                          NormalizeDouble(Profit, Digits),
	                          Expert_Name+" SELL:"+sLevel,Magic,0,Red);
   
         if(ticket > 0) 
         {
            if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
            {
            if(ECN_Mode > 0 && (SellStop > 0 || SellProfit > 0)) 
               OrderModify(ticket,OrderOpenPrice(),SellStop,SellProfit,0,Magenta);
            pTime=Time[0];
            BEvent=0;
            }
         }
      	else 	
         if(GetLastError()>0)
         Print("SELL: OrderSend failed with error #",GetLastError());
      }
   }      
   return(0);
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     
   double BuyPrice  = Ask, Stop, Profit;
   double StopPrice = Ask;
   int    Mode      = OP_BUY;
   
   if (StopLoss > 0) double BuyStop  = StopPrice - StopLoss*_Point; 
	else 
	if (TrailingMode==2 && stopDnBand > 0) BuyStop = stopDnBand; 
	else 
	BuyStop = 0;
   
   if(BuyStop > 0 && StopPrice - BuyStop < 10*_Point) BuyStop = StopPrice - 10*_Point; 
    
   if (TakeProfit  > 0) double BuyProfit= BuyPrice + TakeProfit*_Point;   
	else 
	BuyProfit=0;
   	 
	if (MM == 2 && BuyStop > 0) MaxLoss = tick_val*(BuyPrice - BuyStop)/_Point; 
	
	if(ECN_Mode > 0) {Stop = 0; Profit = 0;}
	else {Stop = BuyStop; Profit = BuyProfit;} 
	
	if (MoneyManagement(1))
	{
	   
	   for (int i=0; i<NumOrders;i++)
      {	
      int ticket = OrderSend(Symbol(),Mode, aLots[i],
                             NormalizeDouble(BuyPrice , Digits),
	                          Slippage,
	                          NormalizeDouble(Stop  , Digits), 
	                          NormalizeDouble(Profit, Digits),
	                          Expert_Name+" BUY:"+bLevel,Magic,0,Blue);
      
         if(ticket > 0) 
         {
            if (OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) 
            {
            if(ECN_Mode == 1 && (BuyStop > 0 || BuyProfit > 0)) 
               OrderModify(ticket,OrderOpenPrice(),BuyStop,BuyProfit,0,Aqua);
            pTime=Time[0];
            BEvent=0; 
            }
         }
	      else 	
         if(GetLastError()>0)      
         Print("BUY : OrderSend failed with error #",GetLastError());
      }
   }      
   return(0);
} 

bool CloseOrder(int mode)  
{
   bool result=false; 
   int  total=OrdersTotal();
   
   for (int i=0; i<OrdersTotal(); i++)  
   {
   OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) 
      {
      if ((mode == 0 || mode ==1) && OrderType()==OP_BUY ) {result=CloseAtMarket(OrderTicket(),OrderLots(),Aqua); break;}
      if ((mode == 0 || mode ==2) && OrderType()==OP_SELL) {result=CloseAtMarket(OrderTicket(),OrderLots(),Pink); break;}
      }
   }
   return(result);
}


bool CloseAtMarket(int ticket,double lot,color clr) 
{
   bool result = false; 
   int  ntr;
      
   int tries=0;
   while (!result && tries < TriesNum) 
   {
      RefreshRates();
      result=OrderClose(ticket,lot,OrderClosePrice(),Slippage,clr);
      tries++;
   }
   if (!result) Print("Error closing order : ",ErrorDescription(GetLastError()));
   return(result);
}

double TotalProfit(int pmode)
{
   int total = OrdersTotal();
   double Pips = 0, profit=0, totalPips = 0, totalProfits = 0;
   
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( Magic>0 && OrderMagicNumber()==Magic && OrderSymbol() == Symbol()) condition = true;
   else if ( Magic==0 ) condition = true;   
      if (condition)
      {      
         switch (mode)
         {
         case OP_BUY:
            Pips = (MarketInfo(Symbol(),MODE_BID)-OrderOpenPrice())/_Point;
            profit = OrderProfit() + OrderSwap() + OrderCommission();
            totalPips += Pips;
            totalProfits += profit;
            break;
            
         case OP_SELL:
            Pips = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/_Point;
            profit = OrderProfit() + OrderSwap() + OrderCommission();
            totalPips += Pips;
            totalProfits += profit;
            break;
         }
      }            
	}
   if(pmode==0) return(Pips);
   else
   if(pmode==1) return(profit);
   else
   if(pmode==2) return(totalPips);
   else
   if(pmode==3) return(totalProfits);
}

bool ProfitClose(int trade,int pmode,double value,double dur)
{
   bool result = false;
   int total = OrdersTotal();
   double Pips = 0, profit=0;
   
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if (Magic>0 && OrderMagicNumber() == Magic && OrderSymbol() == Symbol()) condition = true;
   else if (Magic == 0) condition = true;   
      if (condition  && TimeCurrent() - OrderOpenTime() > dur*60)
      {      
         if(mode == OP_BUY && (trade == 1 || trade == 0))
         {
         Pips = (MarketInfo(Symbol(),MODE_BID)-OrderOpenPrice())/_Point;
         profit = OrderProfit();
            if(pmode == 0 && Pips >= value) result = CloseAtMarket(OrderTicket(),OrderLots(),GreenYellow);
            else
            if(pmode == 1 && profit >= value) result = CloseAtMarket(OrderTicket(),OrderLots(),GreenYellow);               
         }   
         else   
         if(mode == OP_SELL && (trade == 2 || trade == 0))
         {
         Pips = (OrderOpenPrice()-MarketInfo(Symbol(),MODE_ASK))/_Point;
         profit = OrderProfit();
            if(pmode == 0 && Pips >= value) result = CloseAtMarket(OrderTicket(),OrderLots(),Gold); 
            else
            if(pmode == 1 && profit >= value) result = CloseAtMarket(OrderTicket(),OrderLots(),Gold);
         }
      }            
	}
   return(result);
}

void ChartComment()
{
   string sComment   = "";
   string sp         = "----------------------------------------\n";
   string NL         = "\n";
       
   sComment = sp;
   sComment = sComment+"ExpertName : "+Expert_Name+NL;
   sComment = sComment+"Open Orders= "+ScanTrades(0,1)+NL;
   sComment = sComment+"Current Profit(pips)= " + DoubleToStr(TotalProfit(2),2) + NL;
   sComment = sComment+"Current Profit("+ AccountCurrency()+") = " + DoubleToStr(TotalProfit(3),2) + NL; 
   sComment = sComment+sp;
   if(TimeCondition()) string tc = "OK"; else tc = "NO"; 
   sComment = sComment+"Current Time : "+TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS) + " DayOfWeek : " + TimeDayOfWeek(TimeCurrent()) + " Time Condition : " + tc + NL;
   
   Comment(sComment);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(iBars(Symbol(),MainTimeFrame) < PS_Length || !IsTradeAllowed() || PS_Sigma_max < PS_Sigma_min) return(0); 
   
   if (ScheduleMode > 0 && fTime)
   {
      if(ScheduleName != "")
      {   
      ReadSchedule(ScheduleName);
      fTime = false;
      }
      else 
      {
      Print("Attention! Wrong Schedule:",ScheduleName,"time=",TimeToStr(TimeCurrent())); 
      return(0);
      }
   }
   
   CurrBar = iTime(Symbol(),MainTimeFrame,0);
   spread = Ask - Bid;
   
   if ((CurrBar != PrevBar && PS_Shift>0) || PS_Shift==0)
   {
   if(Comment_Mode > 0) ChartComment();
   
   int Trades = ScanTrades(0,0);
   datetime min = iTime(NULL,1,0);
   if(min != pmin) {timecond = TimeCondition(); pmin = min;}
   
   if(!timecond && Trades == 0) return(0);     
   
   if(timecond || (!timecond && Trades > 0)) int Signal = TradeSignal();   
      
      if(Trades > 0)
      {
      if(BreakEven > 0 || TrailingMode>0) TrailStop();
      
      double pips = TotalProfit(ProfitMode);   
         if(ExitMode == 1)
         {
         if(ProfitTarget > 0) ProfitClose(0,ProfitMode,ProfitTarget,OrdDuration); 
          
         if(Bid <= UpBand[0] - ProfitRatio*(UpBand[0] - DnBand[0]))
         { 
         //Print("Ask<=Mid",Ask,"<=",ProfitRatio*(UpBand[0] - DnBand[0]));
         if(ScanTrades(2,0) > 1 && TotalProfit(3) > 0) while(ScanTrades(2,0)>0) CloseOrder(2);
         ProfitClose(2,0,MinProfit,OrdDuration);
         }
         
         if(Bid >= DnBand[0] + ProfitRatio*(UpBand[0] - DnBand[0])) 
         {
         if(ScanTrades(1,0) > 1 && TotalProfit(3) > 0) while(ScanTrades(1,0)>0) CloseOrder(1);
         ProfitClose(1,0,MinProfit,OrdDuration);
         }
         
         if(Ask <= DnBand[0] - LossRatio*(UpBand[0] - DnBand[0])) while(ScanTrades(2,0)>0) CloseOrder(2);
         if(Bid >= UpBand[0] + LossRatio*(UpBand[0] - DnBand[0]) + spread) while(ScanTrades(1,0)>0) CloseOrder(1);   
                     
            if(StopDeviation > 0)
            {
            if(Bid >= stopUpBand) while(ScanTrades(2,0)>0) CloseOrder(2);
            if(Ask <= stopDnBand) while(ScanTrades(1,0)>0) CloseOrder(1);
            }
         }
         
      
         if(CloseTimeMode > 0)
         {
         datetime TimeClose = StrToTime(CloseHour+":"+CloseMinute); 
         if(DayOfWeek() == 5) TimeClose = StrToTime(FriCloseHour+":"+FriCloseMinute);
         if(TimeCurrent() >= TimeClose && TimeCurrent() < TimeClose+ProcessTime*60) while(ScanTrades(0,0)>0) CloseOrder(0); 
         }
      }
            
      Trades = ScanTrades(0,0);
      
      if(Trades == MaxOrders) Signal = 0;
     
      if(Trades < MaxOrders && Time[0] != pTime && Signal != 0)
      {
         if(timecond)
         {   
         if(Signal > 0) BuyOrdOpen();
         if(Signal < 0) SellOrdOpen();
         }
      }
   }
      
   PrevBar = CurrBar;
   
//----
   return(0);
} //start()
//+------------------------------------------------------------------+

